' VerbPrint.VBS V1.02 (C) yoshioka.teruo@nifty.com 2008-01-26
' VerbPrint.VBS prints files by association of file type.
' Usage: VerbPrint.VBS files...

Option Explicit
Dim Shell
Dim ie
Dim n
Dim fso
Dim Path
Dim File
Dim Folder
Dim FolderItem
Dim Verb

Set Shell=CreateObject("Shell.Application")
For n=0 To 99
  For Each ie In Shell.Windows()
    If ie.ReadyState<>4 Then
    ElseIf ie.Busy Then
    ElseIf n=0 And Not ie.Visible Then
    ElseIf n>0 And ie.Visible Then
    ElseIf InStr(TypeName(ie.Document),"IShellFolderViewDual") Then
      Exit For
    End If
  Next
  If Not IsEmpty(ie) Then Exit For
  If n=0 Then CreateObject("WScript.Shell").Run "Explorer.exe",0,True
  WScript.Sleep 100
Next
If IsEmpty(ie) Then
  WScript.Echo "Failed"
  WScript.Quit
End If
Set Shell=ie.Document.Application
If InStr(TypeName(Shell),"IShellDispatch")=0 Then
  WScript.Echo TypeName(Shell)
  WScript.Quit
End If

Set fso=CreateObject("Scripting.FileSystemObject")
For Each Path In WScript.Arguments
  Set File=fso.GetFile(Path)
  Set Folder=Shell.NameSpace(File.Path&"\..\")
  Set FolderItem=Folder.ParseName(File.Name)
  For Each Verb In FolderItem.Verbs
    Select Case Verb.Name
    Case "(&P)","" Exit For
    End Select
  Next
  If IsEmpty(Verb) Then
    WScript.Echo "No Print Verb."
    Call FolderItem.InvokeVerb("print")
  Else
    Verb.DoIt
    Set Verb=Nothing
  End If
  Set FolderItem=Nothing
  Set Folder=Nothing
Next
Set Shell=Nothing
If n Then If ie.Visible=False Then ie.Quit
